

// From Scene World to Map World

var HEADING;
var TILT;
var ROLL;

var heading = HEADING*Math.PI/180;
var tilt = TILT*Math.PI/180;
var roll = ROLL*Math.PI/180;

// Altitude is relative. Not caring.

// Roll
var z = new x3dom.fields.SFVec3f(0,0,1);
var qr = x3dom.fields.Quaternion.axisAngle(z,roll);
var M_roll = qr.toMatrix();

// Tilt
var x = new x3dom.fields.SFVec3f(1,0,0);
var qt = x3dom.fields.Quaternion.axisAngle(x,tilt);
var M_tilt = qt.toMatrix();

// Heading
var y = new x3dom.fields.SFVec3f(0,1,0);
var qh = x3dom.fields.Quaternion.axisAngle(y,-heading);
var M_heading = qh.toMatrix();

var M = M_heading.mult(M_tilt).mult(M_roll);


// Now because the model is oriented to North it needs a correction!